'use strict';

var path      = require('path')
  , generators    = require('yeoman-generator')
  , yosay     = require('yosay')
var isGuestUseCase = false;
var GuestGenerator = generators.Base.extend({
  constructor: function () {
    generators.Base.apply(this, arguments);

    this.desc('Generate Service Fabric guest application template');
  },

  prompting: function () {
    var done = this.async();

    this.log(yosay(
        'Welcome to Service Fabric guest application generator'
    ));
    

    var prompts = [{
      type: 'list'
      , name: 'frameworkType'
      , message: 'Choose a framework for your service'
      , default: this.config.get('frameworkType')
      , choices: ["Guest Binary", "Container"]
      }, {
      type: 'input'
    , name: 'projName'
    , message: 'Name your application'
    , default: this.config.get('projName')
    , validate: function (input) {
        return input ? true : false;
      }
    }];

    this.prompt(prompts, function (props) {
      this.props = props;
      this.props.projName = this.props.projName.trim();
      this.config.set(props);

      done();
    }.bind(this));
  },

  writing: function() {
    if (this.props.frameworkType == "Guest Binary") {
        this.composeWith('azuresfguest:guestbinary');
    } else if (this.props.frameworkType == "Container") {
        this.composeWith('azuresfguest:guestcontainer');
    }
  },
  
  end: function () {
    this.config.save();
  }
});

module.exports = GuestGenerator;

